
// CSS Object Model (CSSOM)
// Specification: https://drafts.csswg.org/cssom-1/
// Repository: https://github.com/w3c/csswg-drafts/tree/main/cssom-1

// This file is auto-generated from my CSS properties index (https://benjaminaster.com/webindex/css.html).
// The properties already in TypeScript's standard type declarations were removed.

interface CSSStyleDeclaration {
	anchorDefault: string;
	anchorName: string;
	animationRange: string;
	animationRangeEnd: string;
	animationRangeStart: string;
	animationTimeline: string;
	appRegion: string;
	backgroundPositionBlock: string;
	backgroundPositionInline: string;
	baselineSource: string;
	blockEllipsis: string;
	blockStep: string;
	blockStepAlign: string;
	blockStepInsert: string;
	blockStepRound: string;
	blockStepSize: string;
	bookmarkLabel: string;
	bookmarkLevel: string;
	bookmarkState: string;
	borderBlockEndRadius: string;
	borderBlockStartRadius: string;
	borderBottomRadius: string;
	borderBoundary: string;
	borderClip: string;
	borderClipBottom: string;
	borderClipLeft: string;
	borderClipRight: string;
	borderClipTop: string;
	borderInlineEndRadius: string;
	borderInlineStartRadius: string;
	borderLeftRadius: string;
	borderLimit: string;
	borderRightRadius: string;
	borderTopRadius: string;
	boxDecorationBreak: string;
	boxShadowBlur: string;
	boxShadowColor: string;
	boxShadowOffset: string;
	boxShadowPosition: string;
	boxShadowSpread: string;
	boxSnap: string;
	caret: string;
	caretShape: string;
	colorAdjust: string;
	contentVisibility: string;
	continue: string;
	copyInto: string;
	cornerShape: string;
	corners: string;
	cue: string;
	cueAfter: string;
	cueBefore: string;
	cx: string;
	cy: string;
	d: string;
	fieldSizing: string;
	fillBreak: string;
	fillColor: string;
	fillImage: string;
	fillOrigin: string;
	fillPosition: string;
	fillRepeat: string;
	fillSize: string;
	floatDefer: string;
	floatOffset: string;
	floatReference: string;
	flowFrom: string;
	flowInto: string;
	fontLanguageOverride: string;
	fontSynthesisPosition: string;
	fontVariantEmoji: string;
	footnoteDisplay: string;
	footnotePolicy: string;
	glyphOrientationVertical: string;
	hangingPunctuation: string;
	hyphenateLimitChars: string;
	hyphenateLimitLast: string;
	hyphenateLimitLines: string;
	hyphenateLimitZone: string;
	imageResolution: string;
	initialLetter: string;
	initialLetterAlign: string;
	initialLetterWrap: string;
	inlineSizing: string;
	inputSecurity: string;
	insetArea: string;
	layoutOrder: string;
	lineClamp: string;
	lineGrid: string;
	lineHeightStep: string;
	linePadding: string;
	lineSnap: string;
	linkParameters: string;
	marginBreak: string;
	marginTrim: string;
	markerSide: string;
	maskBorder: string;
	maskBorderMode: string;
	maskBorderOutset: string;
	maskBorderRepeat: string;
	maskBorderSlice: string;
	maskBorderSource: string;
	maskBorderWidth: string;
	masonryAutoFlow: string;
	mathDepth: string;
	mathShift: string;
	maxContentInlineSize: string;
	maxLines: string;
	minContentInlineSize: string;
	minIntrinsicSizing: string;
	navDown: string;
	navLeft: string;
	navRight: string;
	navUp: string;
	objectViewBox: string;
	offsetAnchor: string;
	offsetPosition: string;
	overflowBlock: string;
	overflowClipMarginBlock: string;
	overflowClipMarginBlockEnd: string;
	overflowClipMarginBlockStart: string;
	overflowClipMarginBottom: string;
	overflowClipMarginInline: string;
	overflowClipMarginInlineEnd: string;
	overflowClipMarginInlineStart: string;
	overflowClipMarginLeft: string;
	overflowClipMarginRight: string;
	overflowClipMarginTop: string;
	overflowInline: string;
	overlay: string;
	pause: string;
	pauseAfter: string;
	pauseBefore: string;
	positionFallback: string;
	positionFallbackBounds: string;
	r: string;
	readingOrder: string;
	regionFragment: string;
	rest: string;
	restAfter: string;
	restBefore: string;
	rubyAlign: string;
	rubyMerge: string;
	rubyOverhang: string;
	rx: string;
	ry: string;
	scrollStart: string;
	scrollStartBlock: string;
	scrollStartInline: string;
	scrollStartTarget: string;
	scrollStartTargetBlock: string;
	scrollStartTargetInline: string;
	scrollStartTargetX: string;
	scrollStartTargetY: string;
	scrollStartX: string;
	scrollStartY: string;
	scrollTimeline: string;
	scrollTimelineAxis: string;
	scrollTimelineName: string;
	scrollbarColor: string;
	scrollbarWidth: string;
	shapeInside: string;
	shapePadding: string;
	shapeSubtract: string;
	spatialNavigationAction: string;
	spatialNavigationContain: string;
	spatialNavigationFunction: string;
	speak: string;
	speakAs: string;
	stringSet: string;
	strokeAlign: string;
	strokeBreak: string;
	strokeColor: string;
	strokeDashCorner: string;
	strokeDashJustify: string;
	strokeImage: string;
	strokeOrigin: string;
	strokePosition: string;
	strokeRepeat: string;
	strokeSize: string;
	textAlignAll: string;
	textAutospace: string;
	textBoxEdge: string;
	textBoxTrim: string;
	textDecorationSkip: string;
	textDecorationSkipBox: string;
	textDecorationSkipSelf: string;
	textDecorationSkipSpaces: string;
	textDecorationTrim: string;
	textEmphasisSkip: string;
	textGroupAlign: string;
	textJustify: string;
	textSizeAdjust: string;
	textSpacing: string;
	textSpacingTrim: string;
	textWrap: string;
	textWrapMode: string;
	textWrapStyle: string;
	timelineScope: string;
	toggle: string;
	toggleGroup: string;
	toggleRoot: string;
	toggleTrigger: string;
	toggleVisibility: string;
	transitionBehavior: string;
	vectorEffect: string;
	viewTimeline: string;
	viewTimelineAxis: string;
	viewTimelineInset: string;
	viewTimelineName: string;
	viewTransitionName: string;
	voiceBalance: string;
	voiceDuration: string;
	voiceFamily: string;
	voicePitch: string;
	voiceRange: string;
	voiceRate: string;
	voiceStress: string;
	voiceVolume: string;
	webkitAppRegion: string;
	webkitTextSecurity: string;
	whiteSpaceCollapse: string;
	whiteSpaceTrim: string;
	wordSpaceTransform: string;
	wrapAfter: string;
	wrapBefore: string;
	wrapFlow: string;
	wrapInside: string;
	wrapThrough: string;
	x: string;
	y: string;
}
